﻿using ProjectElectricLocomotive.Entities;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectElectricLocomotive.DrawingObjects
{
    public class DrawingElectricLocomotive : DrawingLocomotive
    {
        public DrawingElectricLocomotive(int speed, double weight, Color bodyColor, Color additionalColor,
            bool horns, bool seifBatteries, int width, int height) : base(speed, weight, bodyColor, width, height, 85, 50)
        {
            if (EntityLocomotive != null)
            {
                EntityLocomotive = new EntityElectricLocomotive(speed, weight, bodyColor, additionalColor, horns, seifBatteries);
            }
        }
        public override void DrawTransport(Graphics g)
        {
            if (EntityLocomotive is not EntityElectricLocomotive electricLocomotive)
            {
                return;
            }

            Pen pen = new Pen(electricLocomotive.AdditionalColor);
            Brush blackBrush = new SolidBrush(Color.Black);
            Brush additionalBrush = new SolidBrush(electricLocomotive.AdditionalColor);

            if (electricLocomotive.Horns)
            {
                //horns
                g.FillRectangle(additionalBrush, _startPosX + 30, _startPosY + 15, 20, 5);
                g.DrawLine(pen, _startPosX + 40, _startPosY + 15, _startPosX + 50, _startPosY + 10);
                g.DrawLine(pen, _startPosX + 50, _startPosY + 10, _startPosX + 45, _startPosY);
                g.DrawLine(pen, _startPosX + 45, _startPosY + 15, _startPosX + 50, _startPosY + 10);
                g.DrawLine(pen, _startPosX + 50, _startPosY + 10, _startPosX + 40, _startPosY);
            }

            if (electricLocomotive.SeifBatteries)
            {
                g.FillRectangle(additionalBrush, _startPosX + 80, _startPosY + 30, 5, 10);
            }
            base.DrawTransport(g);
        }

        public void SetAddColor(Color color)
        {
            (EntityLocomotive as EntityElectricLocomotive).SetAdditionalColor(color);
        }
    }
}