﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectElectricLocomotive.MovementStrategy
{
    public class ObjectParameters
    {
        private readonly int _x;
        private readonly int _y;
        private readonly int _width;
        private readonly int _height;
        
        /// Левая граница
        public int LeftBorder => _x;
       
        /// Верхняя граница
        public int TopBorder => _y;

        /// Правая граница
        public int RightBorder => _x + _width;

        /// Нижняя граница
        public int DownBorder => _y + _height;

        /// Середина объекта по горизонтали
        public int ObjectMiddleHorizontal => _x + _width / 2;

        /// Середина объекта по вертикали
        public int ObjectMiddleVertical => _y + _height / 2;

        public ObjectParameters(int x, int y, int width, int height)
        {
            _x = x;
            _y = y;
            _width = width;
            _height = height;
        }
    }
}
